<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAcceptedPaymentsTypeAcceptedPayment ArrayType
 * @subpackage Arrays
 */
class ArrayOfAcceptedPaymentsTypeAcceptedPayment extends AbstractStructArrayBase
{
    /**
     * The AcceptedPayment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AcceptedPayment[]
     */
    public $AcceptedPayment;
    /**
     * Constructor method for ArrayOfAcceptedPaymentsTypeAcceptedPayment
     * @uses ArrayOfAcceptedPaymentsTypeAcceptedPayment::setAcceptedPayment()
     * @param \StructType\AcceptedPayment[] $acceptedPayment
     */
    public function __construct(array $acceptedPayment = array())
    {
        $this
            ->setAcceptedPayment($acceptedPayment);
    }
    /**
     * Get AcceptedPayment value
     * @return \StructType\AcceptedPayment[]|null
     */
    public function getAcceptedPayment()
    {
        return $this->AcceptedPayment;
    }
    /**
     * This method is responsible for validating the values passed to the setAcceptedPayment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAcceptedPayment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAcceptedPaymentForArrayConstraintsFromSetAcceptedPayment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAcceptedPaymentsTypeAcceptedPaymentAcceptedPaymentItem) {
            // validation for constraint: itemType
            if (!$arrayOfAcceptedPaymentsTypeAcceptedPaymentAcceptedPaymentItem instanceof \StructType\AcceptedPayment) {
                $invalidValues[] = is_object($arrayOfAcceptedPaymentsTypeAcceptedPaymentAcceptedPaymentItem) ? get_class($arrayOfAcceptedPaymentsTypeAcceptedPaymentAcceptedPaymentItem) : sprintf('%s(%s)', gettype($arrayOfAcceptedPaymentsTypeAcceptedPaymentAcceptedPaymentItem), var_export($arrayOfAcceptedPaymentsTypeAcceptedPaymentAcceptedPaymentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AcceptedPayment property can only contain items of type \StructType\AcceptedPayment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AcceptedPayment value
     * @throws \InvalidArgumentException
     * @param \StructType\AcceptedPayment[] $acceptedPayment
     * @return \ArrayType\ArrayOfAcceptedPaymentsTypeAcceptedPayment
     */
    public function setAcceptedPayment(array $acceptedPayment = array())
    {
        // validation for constraint: array
        if ('' !== ($acceptedPaymentArrayErrorMessage = self::validateAcceptedPaymentForArrayConstraintsFromSetAcceptedPayment($acceptedPayment))) {
            throw new \InvalidArgumentException($acceptedPaymentArrayErrorMessage, __LINE__);
        }
        $this->AcceptedPayment = $acceptedPayment;
        return $this;
    }
    /**
     * Add item to AcceptedPayment value
     * @throws \InvalidArgumentException
     * @param \StructType\AcceptedPayment $item
     * @return \ArrayType\ArrayOfAcceptedPaymentsTypeAcceptedPayment
     */
    public function addToAcceptedPayment(\StructType\AcceptedPayment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AcceptedPayment) {
            throw new \InvalidArgumentException(sprintf('The AcceptedPayment property can only contain items of type \StructType\AcceptedPayment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AcceptedPayment[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AcceptedPayment|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AcceptedPayment|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AcceptedPayment|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AcceptedPayment|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AcceptedPayment|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AcceptedPayment
     */
    public function getAttributeName()
    {
        return 'AcceptedPayment';
    }
}
