<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHotelReservationsTypeHotelReservation ArrayType
 * @subpackage Arrays
 */
class ArrayOfHotelReservationsTypeHotelReservation extends AbstractStructArrayBase
{
    /**
     * The HotelReservation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\HotelReservation[]
     */
    public $HotelReservation;
    /**
     * Constructor method for ArrayOfHotelReservationsTypeHotelReservation
     * @uses ArrayOfHotelReservationsTypeHotelReservation::setHotelReservation()
     * @param \StructType\HotelReservation[] $hotelReservation
     */
    public function __construct(array $hotelReservation = array())
    {
        $this
            ->setHotelReservation($hotelReservation);
    }
    /**
     * Get HotelReservation value
     * @return \StructType\HotelReservation[]|null
     */
    public function getHotelReservation()
    {
        return $this->HotelReservation;
    }
    /**
     * This method is responsible for validating the values passed to the setHotelReservation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHotelReservation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHotelReservationForArrayConstraintsFromSetHotelReservation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfHotelReservationsTypeHotelReservationHotelReservationItem) {
            // validation for constraint: itemType
            if (!$arrayOfHotelReservationsTypeHotelReservationHotelReservationItem instanceof \StructType\HotelReservation) {
                $invalidValues[] = is_object($arrayOfHotelReservationsTypeHotelReservationHotelReservationItem) ? get_class($arrayOfHotelReservationsTypeHotelReservationHotelReservationItem) : sprintf('%s(%s)', gettype($arrayOfHotelReservationsTypeHotelReservationHotelReservationItem), var_export($arrayOfHotelReservationsTypeHotelReservationHotelReservationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HotelReservation property can only contain items of type \StructType\HotelReservation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HotelReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelReservation[] $hotelReservation
     * @return \ArrayType\ArrayOfHotelReservationsTypeHotelReservation
     */
    public function setHotelReservation(array $hotelReservation = array())
    {
        // validation for constraint: array
        if ('' !== ($hotelReservationArrayErrorMessage = self::validateHotelReservationForArrayConstraintsFromSetHotelReservation($hotelReservation))) {
            throw new \InvalidArgumentException($hotelReservationArrayErrorMessage, __LINE__);
        }
        $this->HotelReservation = $hotelReservation;
        return $this;
    }
    /**
     * Add item to HotelReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelReservation $item
     * @return \ArrayType\ArrayOfHotelReservationsTypeHotelReservation
     */
    public function addToHotelReservation(\StructType\HotelReservation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HotelReservation) {
            throw new \InvalidArgumentException(sprintf('The HotelReservation property can only contain items of type \StructType\HotelReservation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HotelReservation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HotelReservation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HotelReservation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HotelReservation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HotelReservation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HotelReservation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelReservation
     */
    public function getAttributeName()
    {
        return 'HotelReservation';
    }
}
