<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHotelSearchCriterionTypeRoomStayCandidate ArrayType
 * @subpackage Arrays
 */
class ArrayOfHotelSearchCriterionTypeRoomStayCandidate extends AbstractStructArrayBase
{
    /**
     * The RoomStayCandidate
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RoomStayCandidate[]
     */
    public $RoomStayCandidate;
    /**
     * Constructor method for ArrayOfHotelSearchCriterionTypeRoomStayCandidate
     * @uses ArrayOfHotelSearchCriterionTypeRoomStayCandidate::setRoomStayCandidate()
     * @param \StructType\RoomStayCandidate[] $roomStayCandidate
     */
    public function __construct(array $roomStayCandidate = array())
    {
        $this
            ->setRoomStayCandidate($roomStayCandidate);
    }
    /**
     * Get RoomStayCandidate value
     * @return \StructType\RoomStayCandidate[]|null
     */
    public function getRoomStayCandidate()
    {
        return $this->RoomStayCandidate;
    }
    /**
     * This method is responsible for validating the values passed to the setRoomStayCandidate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoomStayCandidate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoomStayCandidateForArrayConstraintsFromSetRoomStayCandidate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfHotelSearchCriterionTypeRoomStayCandidateRoomStayCandidateItem) {
            // validation for constraint: itemType
            if (!$arrayOfHotelSearchCriterionTypeRoomStayCandidateRoomStayCandidateItem instanceof \StructType\RoomStayCandidate) {
                $invalidValues[] = is_object($arrayOfHotelSearchCriterionTypeRoomStayCandidateRoomStayCandidateItem) ? get_class($arrayOfHotelSearchCriterionTypeRoomStayCandidateRoomStayCandidateItem) : sprintf('%s(%s)', gettype($arrayOfHotelSearchCriterionTypeRoomStayCandidateRoomStayCandidateItem), var_export($arrayOfHotelSearchCriterionTypeRoomStayCandidateRoomStayCandidateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoomStayCandidate property can only contain items of type \StructType\RoomStayCandidate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoomStayCandidate value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomStayCandidate[] $roomStayCandidate
     * @return \ArrayType\ArrayOfHotelSearchCriterionTypeRoomStayCandidate
     */
    public function setRoomStayCandidate(array $roomStayCandidate = array())
    {
        // validation for constraint: array
        if ('' !== ($roomStayCandidateArrayErrorMessage = self::validateRoomStayCandidateForArrayConstraintsFromSetRoomStayCandidate($roomStayCandidate))) {
            throw new \InvalidArgumentException($roomStayCandidateArrayErrorMessage, __LINE__);
        }
        $this->RoomStayCandidate = $roomStayCandidate;
        return $this;
    }
    /**
     * Add item to RoomStayCandidate value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomStayCandidate $item
     * @return \ArrayType\ArrayOfHotelSearchCriterionTypeRoomStayCandidate
     */
    public function addToRoomStayCandidate(\StructType\RoomStayCandidate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RoomStayCandidate) {
            throw new \InvalidArgumentException(sprintf('The RoomStayCandidate property can only contain items of type \StructType\RoomStayCandidate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoomStayCandidate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RoomStayCandidate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RoomStayCandidate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RoomStayCandidate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RoomStayCandidate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RoomStayCandidate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RoomStayCandidate
     */
    public function getAttributeName()
    {
        return 'RoomStayCandidate';
    }
}
