<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfResGuestType ArrayType
 * @subpackage Arrays
 */
class ArrayOfResGuestType extends AbstractStructArrayBase
{
    /**
     * The ResGuest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ResGuestType[]
     */
    public $ResGuest;
    /**
     * Constructor method for ArrayOfResGuestType
     * @uses ArrayOfResGuestType::setResGuest()
     * @param \StructType\ResGuestType[] $resGuest
     */
    public function __construct(array $resGuest = array())
    {
        $this
            ->setResGuest($resGuest);
    }
    /**
     * Get ResGuest value
     * @return \StructType\ResGuestType[]|null
     */
    public function getResGuest()
    {
        return $this->ResGuest;
    }
    /**
     * This method is responsible for validating the values passed to the setResGuest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setResGuest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateResGuestForArrayConstraintsFromSetResGuest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfResGuestTypeResGuestItem) {
            // validation for constraint: itemType
            if (!$arrayOfResGuestTypeResGuestItem instanceof \StructType\ResGuestType) {
                $invalidValues[] = is_object($arrayOfResGuestTypeResGuestItem) ? get_class($arrayOfResGuestTypeResGuestItem) : sprintf('%s(%s)', gettype($arrayOfResGuestTypeResGuestItem), var_export($arrayOfResGuestTypeResGuestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ResGuest property can only contain items of type \StructType\ResGuestType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ResGuest value
     * @throws \InvalidArgumentException
     * @param \StructType\ResGuestType[] $resGuest
     * @return \ArrayType\ArrayOfResGuestType
     */
    public function setResGuest(array $resGuest = array())
    {
        // validation for constraint: array
        if ('' !== ($resGuestArrayErrorMessage = self::validateResGuestForArrayConstraintsFromSetResGuest($resGuest))) {
            throw new \InvalidArgumentException($resGuestArrayErrorMessage, __LINE__);
        }
        $this->ResGuest = $resGuest;
        return $this;
    }
    /**
     * Add item to ResGuest value
     * @throws \InvalidArgumentException
     * @param \StructType\ResGuestType $item
     * @return \ArrayType\ArrayOfResGuestType
     */
    public function addToResGuest(\StructType\ResGuestType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ResGuestType) {
            throw new \InvalidArgumentException(sprintf('The ResGuest property can only contain items of type \StructType\ResGuestType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ResGuest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ResGuestType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ResGuestType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ResGuestType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ResGuestType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ResGuestType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ResGuest
     */
    public function getAttributeName()
    {
        return 'ResGuest';
    }
}
