<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfRoomStaysTypeRoomStay ArrayType
 * @subpackage Arrays
 */
class ArrayOfRoomStaysTypeRoomStay extends AbstractStructArrayBase
{
    /**
     * The RoomStay
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RoomStay[]
     */
    public $RoomStay;
    /**
     * Constructor method for ArrayOfRoomStaysTypeRoomStay
     * @uses ArrayOfRoomStaysTypeRoomStay::setRoomStay()
     * @param \StructType\RoomStay[] $roomStay
     */
    public function __construct(array $roomStay = array())
    {
        $this
            ->setRoomStay($roomStay);
    }
    /**
     * Get RoomStay value
     * @return \StructType\RoomStay[]|null
     */
    public function getRoomStay()
    {
        return $this->RoomStay;
    }
    /**
     * This method is responsible for validating the values passed to the setRoomStay method
     * This method is willingly generated in order to preserve the one-line inline validation within the setRoomStay method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateRoomStayForArrayConstraintsFromSetRoomStay(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfRoomStaysTypeRoomStayRoomStayItem) {
            // validation for constraint: itemType
            if (!$arrayOfRoomStaysTypeRoomStayRoomStayItem instanceof \StructType\RoomStay) {
                $invalidValues[] = is_object($arrayOfRoomStaysTypeRoomStayRoomStayItem) ? get_class($arrayOfRoomStaysTypeRoomStayRoomStayItem) : sprintf('%s(%s)', gettype($arrayOfRoomStaysTypeRoomStayRoomStayItem), var_export($arrayOfRoomStaysTypeRoomStayRoomStayItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The RoomStay property can only contain items of type \StructType\RoomStay, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set RoomStay value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomStay[] $roomStay
     * @return \ArrayType\ArrayOfRoomStaysTypeRoomStay
     */
    public function setRoomStay(array $roomStay = array())
    {
        // validation for constraint: array
        if ('' !== ($roomStayArrayErrorMessage = self::validateRoomStayForArrayConstraintsFromSetRoomStay($roomStay))) {
            throw new \InvalidArgumentException($roomStayArrayErrorMessage, __LINE__);
        }
        $this->RoomStay = $roomStay;
        return $this;
    }
    /**
     * Add item to RoomStay value
     * @throws \InvalidArgumentException
     * @param \StructType\RoomStay $item
     * @return \ArrayType\ArrayOfRoomStaysTypeRoomStay
     */
    public function addToRoomStay(\StructType\RoomStay $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RoomStay) {
            throw new \InvalidArgumentException(sprintf('The RoomStay property can only contain items of type \StructType\RoomStay, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->RoomStay[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\RoomStay|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\RoomStay|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\RoomStay|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\RoomStay|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\RoomStay|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string RoomStay
     */
    public function getAttributeName()
    {
        return 'RoomStay';
    }
}
