<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'OTA_HotelAvailNotifRQ' => '\\StructType\\OTA_HotelAvailNotifRQ',
            'AvailStatusMessages' => '\\StructType\\AvailStatusMessages',
            'AvailStatusMessageType' => '\\StructType\\AvailStatusMessageType',
            'RestrictionStatus' => '\\StructType\\RestrictionStatus',
            'StatusApplicationControlType' => '\\StructType\\StatusApplicationControlType',
            'ArrayOfDestinationSystemCodesTypeDestinationSystemCode' => '\\ArrayType\\ArrayOfDestinationSystemCodesTypeDestinationSystemCode',
            'DestinationSystemCode' => '\\StructType\\DestinationSystemCode',
            'LengthsOfStayType' => '\\StructType\\LengthsOfStayType',
            'LengthOfStay' => '\\StructType\\LengthOfStay',
            'LOS_Pattern' => '\\StructType\\LOS_Pattern',
            'OTA_HotelAvailNotifRS' => '\\StructType\\OTA_HotelAvailNotifRS',
            'MessageAcknowledgementType' => '\\StructType\\MessageAcknowledgementType',
            'ErrorsType' => '\\StructType\\ErrorsType',
            'ErrorType' => '\\StructType\\ErrorType',
            'FreeTextType' => '\\StructType\\FreeTextType',
            'WarningType' => '\\StructType\\WarningType',
            'SuccessType' => '\\StructType\\SuccessType',
            'WarningsType' => '\\StructType\\WarningsType',
            'ArrayOfRoomStaysTypeRoomStay' => '\\ArrayType\\ArrayOfRoomStaysTypeRoomStay',
            'RoomStay' => '\\StructType\\RoomStay',
            'RoomStayType' => '\\StructType\\RoomStayType',
            'BasicPropertyInfo' => '\\StructType\\BasicPropertyInfo',
            'ArrayOfRoomTypeType' => '\\ArrayType\\ArrayOfRoomTypeType',
            'RoomTypeType' => '\\StructType\\RoomTypeType',
            'Occupancy' => '\\StructType\\Occupancy',
            'ParagraphType' => '\\StructType\\ParagraphType',
            'ListItem' => '\\StructType\\ListItem',
            'FormattedTextTextType' => '\\StructType\\FormattedTextTextType',
            'ArrayOfRoomAmenityPrefType' => '\\ArrayType\\ArrayOfRoomAmenityPrefType',
            'RoomAmenityPrefType' => '\\StructType\\RoomAmenityPrefType',
            'TPA_ExtensionsType' => '\\StructType\\TPA_ExtensionsType',
            'BookingWebSource' => '\\StructType\\BookingWebSource',
            'RoomStayTypeRoomRate_ExtensionsType' => '\\StructType\\RoomStayTypeRoomRate_ExtensionsType',
            'PlacementRates' => '\\StructType\\PlacementRates',
            'PlacementRateType' => '\\StructType\\PlacementRateType',
            'TotalType' => '\\StructType\\TotalType',
            'TaxesType' => '\\StructType\\TaxesType',
            'TaxType' => '\\StructType\\TaxType',
            'DiscountType' => '\\StructType\\DiscountType',
            'PaymentFormType_ExtensionsType' => '\\StructType\\PaymentFormType_ExtensionsType',
            'PaymentInfoType' => '\\StructType\\PaymentInfoType',
            'AddressType_TPA_ExtensionsType' => '\\StructType\\AddressType_TPA_ExtensionsType',
            'ArrayOfRoomStayTypeRatePlan' => '\\ArrayType\\ArrayOfRoomStayTypeRatePlan',
            'RatePlan' => '\\StructType\\RatePlan',
            'RatePlanType' => '\\StructType\\RatePlanType',
            'Guarantee' => '\\StructType\\Guarantee',
            'AmountPercent' => '\\StructType\\AmountPercent',
            'MealsIncluded' => '\\StructType\\MealsIncluded',
            'GuaranteeType' => '\\StructType\\GuaranteeType',
            'Deadline' => '\\StructType\\Deadline',
            'ArrayOfGuaranteeTypeGuaranteeAccepted' => '\\ArrayType\\ArrayOfGuaranteeTypeGuaranteeAccepted',
            'GuaranteeAccepted' => '\\StructType\\GuaranteeAccepted',
            'PaymentFormType' => '\\StructType\\PaymentFormType',
            'Cash' => '\\StructType\\Cash',
            'LoyaltyRedemption' => '\\StructType\\LoyaltyRedemption',
            'LoyaltyCertificate' => '\\StructType\\LoyaltyCertificate',
            'MiscChargeOrder' => '\\StructType\\MiscChargeOrder',
            'Ticket' => '\\StructType\\Ticket',
            'ConjunctionTicketNbr' => '\\StructType\\ConjunctionTicketNbr',
            'Voucher' => '\\StructType\\Voucher',
            'BankAcctType' => '\\StructType\\BankAcctType',
            'EncryptionTokenType' => '\\StructType\\EncryptionTokenType',
            'List_BankAccountType' => '\\StructType\\List_BankAccountType',
            'DirectBillType' => '\\StructType\\DirectBillType',
            'CompanyName' => '\\StructType\\CompanyName',
            'Telephone' => '\\StructType\\Telephone',
            'CompanyNameType' => '\\StructType\\CompanyNameType',
            'AddressInfoType' => '\\StructType\\AddressInfoType',
            'AddressType' => '\\StructType\\AddressType',
            'StreetNmbr' => '\\StructType\\StreetNmbr',
            'BldgRoom' => '\\StructType\\BldgRoom',
            'StreetNmbrType' => '\\StructType\\StreetNmbrType',
            'StateProvType' => '\\StructType\\StateProvType',
            'CountryNameType' => '\\StructType\\CountryNameType',
            'EmailType' => '\\StructType\\EmailType',
            'PaymentCardType' => '\\StructType\\PaymentCardType',
            'Issuer' => '\\StructType\\Issuer',
            'CustLoyalty' => '\\StructType\\CustLoyalty',
            'ThreeDomainSecurity' => '\\StructType\\ThreeDomainSecurity',
            'Gateway' => '\\StructType\\Gateway',
            'AuthenticationVerificationValue' => '\\StructType\\AuthenticationVerificationValue',
            'TransactionPassword' => '\\StructType\\TransactionPassword',
            'Results' => '\\StructType\\Results',
            'SignatureOnFile' => '\\StructType\\SignatureOnFile',
            'List_PaymentCardIssuer' => '\\StructType\\List_PaymentCardIssuer',
            'ArrayOfCommentTypeComment' => '\\ArrayType\\ArrayOfCommentTypeComment',
            'Comment' => '\\StructType\\Comment',
            'AmountPercentType' => '\\StructType\\AmountPercentType',
            'CancelPenaltiesType' => '\\StructType\\CancelPenaltiesType',
            'CancelPenaltyType' => '\\StructType\\CancelPenaltyType',
            'CommissionType' => '\\StructType\\CommissionType',
            'CommissionableAmount' => '\\StructType\\CommissionableAmount',
            'PrepaidAmount' => '\\StructType\\PrepaidAmount',
            'FlatCommission' => '\\StructType\\FlatCommission',
            'CommissionPayableAmount' => '\\StructType\\CommissionPayableAmount',
            'UniqueID_Type' => '\\StructType\\UniqueID_Type',
            'ArrayOfRoomStayTypeRoomRate' => '\\ArrayType\\ArrayOfRoomStayTypeRoomRate',
            'RoomRate' => '\\StructType\\RoomRate',
            'RoomRateType' => '\\StructType\\RoomRateType',
            'ArrayOfRateTypeRate' => '\\ArrayType\\ArrayOfRateTypeRate',
            'Rate' => '\\StructType\\Rate',
            'AmountType' => '\\StructType\\AmountType',
            'Discount' => '\\StructType\\Discount',
            'ArrayOfGuestCountTypeGuestCount' => '\\ArrayType\\ArrayOfGuestCountTypeGuestCount',
            'GuestCount' => '\\StructType\\GuestCount',
            'DateTimeSpanType' => '\\StructType\\DateTimeSpanType',
            'ArrayOfRequiredPaymentsTypeGuaranteePayment' => '\\ArrayType\\ArrayOfRequiredPaymentsTypeGuaranteePayment',
            'GuaranteePayment' => '\\StructType\\GuaranteePayment',
            'Address' => '\\StructType\\Address',
            'ArrayOfAcceptedPaymentsTypeAcceptedPayment' => '\\ArrayType\\ArrayOfAcceptedPaymentsTypeAcceptedPayment',
            'AcceptedPayment' => '\\StructType\\AcceptedPayment',
            'BasicPropertyInfoType' => '\\StructType\\BasicPropertyInfoType',
            'Policy' => '\\StructType\\Policy',
            'PropertyValueMatchType' => '\\StructType\\PropertyValueMatchType',
            'ArrayOfServiceRPHsTypeServiceRPH' => '\\ArrayType\\ArrayOfServiceRPHsTypeServiceRPH',
            'ServiceRPH' => '\\StructType\\ServiceRPH',
            'OTA_HotelAvailRQ' => '\\StructType\\OTA_HotelAvailRQ',
            'AvailRequestSegments' => '\\StructType\\AvailRequestSegments',
            'AvailRequestSegements' => '\\StructType\\AvailRequestSegements',
            'AvailRequestSegmentsType' => '\\StructType\\AvailRequestSegmentsType',
            'AvailRequestSegment' => '\\StructType\\AvailRequestSegment',
            'HotelSearchCriteria' => '\\StructType\\HotelSearchCriteria',
            'HotelSearchCriteriaType' => '\\StructType\\HotelSearchCriteriaType',
            'Criterion' => '\\StructType\\Criterion',
            'HotelSearchCriterionType' => '\\StructType\\HotelSearchCriterionType',
            'RateRange' => '\\StructType\\RateRange',
            'ItemSearchCriterionType' => '\\StructType\\ItemSearchCriterionType',
            'HotelRef' => '\\StructType\\HotelRef',
            'ArrayOfHotelSearchCriterionTypeRoomStayCandidate' => '\\ArrayType\\ArrayOfHotelSearchCriterionTypeRoomStayCandidate',
            'RoomStayCandidate' => '\\StructType\\RoomStayCandidate',
            'RoomStayCandidateType' => '\\StructType\\RoomStayCandidateType',
            'OTA_HotelAvailRS' => '\\StructType\\OTA_HotelAvailRS',
            'RoomStays' => '\\StructType\\RoomStays',
            'Reference' => '\\StructType\\Reference',
            'ProfilesType' => '\\StructType\\ProfilesType',
            'ProfileInfo' => '\\StructType\\ProfileInfo',
            'ProfileType' => '\\StructType\\ProfileType',
            'UserID' => '\\StructType\\UserID',
            'CustomerType' => '\\StructType\\CustomerType',
            'Email' => '\\StructType\\Email',
            'CitizenCountryName' => '\\StructType\\CitizenCountryName',
            'SubAccountBalance' => '\\StructType\\SubAccountBalance',
            'ArrayOfCustomerPreferenceType' => '\\ArrayType\\ArrayOfCustomerPreferenceType',
            'CustomerPreferenceType' => '\\StructType\\CustomerPreferenceType',
            'DocumentType' => '\\StructType\\DocumentType',
            'PersonNameType' => '\\StructType\\PersonNameType',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'DocumentType_TPA_ExtensionsType' => '\\StructType\\DocumentType_TPA_ExtensionsType',
            'CompanyInfoType' => '\\StructType\\CompanyInfoType',
            'ServicesType' => '\\StructType\\ServicesType',
            'ServiceType' => '\\StructType\\ServiceType',
            'ResCommonDetailType' => '\\StructType\\ResCommonDetailType',
            'TimeSpan' => '\\StructType\\TimeSpan',
            'ArrayOfFeeType' => '\\ArrayType\\ArrayOfFeeType',
            'FeeType' => '\\StructType\\FeeType',
            'ResGlobalInfoType' => '\\StructType\\ResGlobalInfoType',
            'ArrayOfHotelReservationIDsTypeHotelReservationID' => '\\ArrayType\\ArrayOfHotelReservationIDsTypeHotelReservationID',
            'HotelReservationID' => '\\StructType\\HotelReservationID',
            'ArrayOfProfilesTypeProfileInfo' => '\\ArrayType\\ArrayOfProfilesTypeProfileInfo',
            'OTA_HotelRatePlanNotifRQ' => '\\StructType\\OTA_HotelRatePlanNotifRQ',
            'RatePlans' => '\\StructType\\RatePlans',
            'HotelRatePlanType' => '\\StructType\\HotelRatePlanType',
            'RatePlanLevelFee' => '\\StructType\\RatePlanLevelFee',
            'Fee' => '\\StructType\\Fee',
            'ArrayOfHotelRatePlanRSMessageTypeRate' => '\\ArrayType\\ArrayOfHotelRatePlanRSMessageTypeRate',
            'RateUploadType' => '\\StructType\\RateUploadType',
            'ArrayOfRateUploadTypeBaseByGuestAmt' => '\\ArrayType\\ArrayOfRateUploadTypeBaseByGuestAmt',
            'BaseByGuestAmt' => '\\StructType\\BaseByGuestAmt',
            'ArrayOfRateUploadTypeAdditionalGuestAmount' => '\\ArrayType\\ArrayOfRateUploadTypeAdditionalGuestAmount',
            'AdditionalGuestAmount' => '\\StructType\\AdditionalGuestAmount',
            'ArrayOfHotelRatePlanTypeDestinationSystemCode' => '\\ArrayType\\ArrayOfHotelRatePlanTypeDestinationSystemCode',
            'ArrayOfHotelRatePlanTypeSupplementPrerequisiteInventory' => '\\ArrayType\\ArrayOfHotelRatePlanTypeSupplementPrerequisiteInventory',
            'Supplement' => '\\StructType\\Supplement',
            'ArrayOfSellableProductsTypeSellableProduct' => '\\ArrayType\\ArrayOfSellableProductsTypeSellableProduct',
            'SellableProduct' => '\\StructType\\SellableProduct',
            'InventoryBlock' => '\\StructType\\InventoryBlock',
            'GuestRoomType' => '\\StructType\\GuestRoomType',
            'Quantities' => '\\StructType\\Quantities',
            'Room' => '\\StructType\\Room',
            'OTA_HotelRatePlanNotifRS' => '\\StructType\\OTA_HotelRatePlanNotifRS',
            'RatePlanCrossRefs' => '\\StructType\\RatePlanCrossRefs',
            'RatePlanCrossRef' => '\\StructType\\RatePlanCrossRef',
            'OTA_HotelRateAmountNotifRQ' => '\\StructType\\OTA_HotelRateAmountNotifRQ',
            'RateAmountMessages' => '\\StructType\\RateAmountMessages',
            'RateAmountMessageType' => '\\StructType\\RateAmountMessageType',
            'ArrayOfRateAmountMessageTypeRate' => '\\ArrayType\\ArrayOfRateAmountMessageTypeRate',
            'OTA_ReadRQ' => '\\StructType\\OTA_ReadRQ',
            'ReadRequests' => '\\StructType\\ReadRequests',
            'HotelReadRequest' => '\\StructType\\HotelReadRequest',
            'SelectionCriteria' => '\\StructType\\SelectionCriteria',
            'ReadRequest' => '\\StructType\\ReadRequest',
            'ProfileReadRequest' => '\\StructType\\ProfileReadRequest',
            'UniqueID' => '\\StructType\\UniqueID',
            'ContactPersonType' => '\\StructType\\ContactPersonType',
            'URL_Type' => '\\StructType\\URL_Type',
            'EmployeeInfoType' => '\\StructType\\EmployeeInfoType',
            'OTA_ResRetrieveRS' => '\\StructType\\OTA_ResRetrieveRS',
            'ReservationsList' => '\\StructType\\ReservationsList',
            'HotelReservationsType' => '\\StructType\\HotelReservationsType',
            'HotelReservation' => '\\StructType\\HotelReservation',
            'HotelReservationType' => '\\StructType\\HotelReservationType',
            'ArrayOfSourceType' => '\\ArrayType\\ArrayOfSourceType',
            'SourceType' => '\\StructType\\SourceType',
            'RequestorID' => '\\StructType\\RequestorID',
            'BookingChannel' => '\\StructType\\BookingChannel',
            'ArrayOfResGuestType' => '\\ArrayType\\ArrayOfResGuestType',
            'ResGuestType' => '\\StructType\\ResGuestType',
            'ArrayOfServiceType' => '\\ArrayType\\ArrayOfServiceType',
            'OTA_NotifReportRQ' => '\\StructType\\OTA_NotifReportRQ',
            'NotifDetails' => '\\StructType\\NotifDetails',
            'HotelNotifReport' => '\\StructType\\HotelNotifReport',
            'HotelReservations' => '\\StructType\\HotelReservations',
            'OTA_NotifReportRQNotifDetailsHotelNotifReportRatePlanMessages' => '\\StructType\\OTA_NotifReportRQNotifDetailsHotelNotifReportRatePlanMessages',
            'OTA_NotifReportRQNotifDetailsHotelNotifReportRatePlanMessage' => '\\StructType\\OTA_NotifReportRQNotifDetailsHotelNotifReportRatePlanMessage',
            'OTA_HotelInvNotifRQ' => '\\StructType\\OTA_HotelInvNotifRQ',
            'SellableProducts' => '\\StructType\\SellableProducts',
            'SellableProductsType' => '\\StructType\\SellableProductsType',
            'OTA_HotelInvNotifRS' => '\\StructType\\OTA_HotelInvNotifRS',
            'InventoryCrossRefs' => '\\StructType\\InventoryCrossRefs',
            'InventoryCrossRef' => '\\StructType\\InventoryCrossRef',
            'OTA_CancelRQ' => '\\StructType\\OTA_CancelRQ',
            'CancellationOverrides' => '\\StructType\\CancellationOverrides',
            'CancelRuleType' => '\\StructType\\CancelRuleType',
            'ArrayOfOTA_CancelRQReason' => '\\ArrayType\\ArrayOfOTA_CancelRQReason',
            'Reason' => '\\StructType\\Reason',
            'OTA_CancelRS' => '\\StructType\\OTA_CancelRS',
            'OTA_HotelDescriptiveInfoRQ' => '\\StructType\\OTA_HotelDescriptiveInfoRQ',
            'HotelDescriptiveInfos' => '\\StructType\\HotelDescriptiveInfos',
            'HotelDescriptiveInfo' => '\\StructType\\HotelDescriptiveInfo',
            'HotelDescriptiveInfoRequestType' => '\\StructType\\HotelDescriptiveInfoRequestType',
            'HotelInfo' => '\\StructType\\HotelInfo',
            'FacilityInfo' => '\\StructType\\FacilityInfo',
            'AffiliationInfo' => '\\StructType\\AffiliationInfo',
            'ContactInfo' => '\\StructType\\ContactInfo',
            'OTA_HotelDescriptiveInfoRS' => '\\StructType\\OTA_HotelDescriptiveInfoRS',
            'HotelDescriptiveContents' => '\\StructType\\HotelDescriptiveContents',
            'HotelDescriptiveContent' => '\\StructType\\HotelDescriptiveContent',
            'HotelDescriptiveContentType' => '\\StructType\\HotelDescriptiveContentType',
            'HotelInfoType' => '\\StructType\\HotelInfoType',
            'Descriptions' => '\\StructType\\Descriptions',
            'MultimediaDescriptions' => '\\StructType\\MultimediaDescriptions',
            'Position' => '\\StructType\\Position',
            'MultimediaDescriptionsType' => '\\StructType\\MultimediaDescriptionsType',
            'MultimediaDescriptionType' => '\\StructType\\MultimediaDescriptionType',
            'ImageItemsType' => '\\StructType\\ImageItemsType',
            'ImageItem' => '\\StructType\\ImageItem',
            'ImageDescriptionType' => '\\StructType\\ImageDescriptionType',
            'ImageFormat' => '\\StructType\\ImageFormat',
            'Description' => '\\StructType\\Description',
            'ImageItemType' => '\\StructType\\ImageItemType',
            'TextItemsType' => '\\StructType\\TextItemsType',
            'TextItem' => '\\StructType\\TextItem',
            'TextDescriptionType' => '\\StructType\\TextDescriptionType',
            'ArrayOfHotelInfoTypeService' => '\\ArrayType\\ArrayOfHotelInfoTypeService',
            'Service' => '\\StructType\\Service',
            'ArrayOfHotelInfoTypeLanguage' => '\\ArrayType\\ArrayOfHotelInfoTypeLanguage',
            'Language' => '\\StructType\\Language',
            'FacilityInfoType' => '\\StructType\\FacilityInfoType',
            'ArrayOfFacilityInfoTypeGuestRoom' => '\\ArrayType\\ArrayOfFacilityInfoTypeGuestRoom',
            'GuestRoom' => '\\StructType\\GuestRoom',
            'TypeRoom' => '\\StructType\\TypeRoom',
            'AffiliationInfoType' => '\\StructType\\AffiliationInfoType',
            'ArrayOfAffiliationInfoTypeAward' => '\\ArrayType\\ArrayOfAffiliationInfoTypeAward',
            'Award' => '\\StructType\\Award',
            'ArrayOfContactInfoRootType' => '\\ArrayType\\ArrayOfContactInfoRootType',
            'ContactInfoRootType' => '\\StructType\\ContactInfoRootType',
            'ContactInfoType' => '\\StructType\\ContactInfoType',
            'ArrayOfAddressesTypeAddress' => '\\ArrayType\\ArrayOfAddressesTypeAddress',
            'OTA_HotelResNotifRQ' => '\\StructType\\OTA_HotelResNotifRQ',
            'ArrayOfHotelReservationsTypeHotelReservation' => '\\ArrayType\\ArrayOfHotelReservationsTypeHotelReservation',
            'OTA_HotelResNotifRS' => '\\StructType\\OTA_HotelResNotifRS',
            'OTA_ProfileCreateRQ' => '\\StructType\\OTA_ProfileCreateRQ',
            'OTA_ProfileCreateRS' => '\\StructType\\OTA_ProfileCreateRS',
            'OTA_HotelInvBlockNotifRQ' => '\\StructType\\OTA_HotelInvBlockNotifRQ',
            'InvBlocks' => '\\StructType\\InvBlocks',
            'InvBlockDates' => '\\StructType\\InvBlockDates',
            'InvBlock' => '\\StructType\\InvBlock',
            'MarketCode' => '\\StructType\\MarketCode',
            'InvBlockType' => '\\StructType\\InvBlockType',
            'MethodInfo' => '\\StructType\\MethodInfo',
            'TaxInformation' => '\\StructType\\TaxInformation',
            'ArrayOfInvBlockRoomType' => '\\ArrayType\\ArrayOfInvBlockRoomType',
            'InvBlockRoomType' => '\\StructType\\InvBlockRoomType',
            'RoomTypeAllocations' => '\\StructType\\RoomTypeAllocations',
            'RoomTypeAllocation' => '\\StructType\\RoomTypeAllocation',
            'ArrayOfInvBlockRoomTypeRatePlan' => '\\ArrayType\\ArrayOfInvBlockRoomTypeRatePlan',
            'ArrayOfDOW_RulesType' => '\\ArrayType\\ArrayOfDOW_RulesType',
            'DOW_RulesType' => '\\StructType\\DOW_RulesType',
            'ArrayOfInvBlockTypeBlockDescription' => '\\ArrayType\\ArrayOfInvBlockTypeBlockDescription',
            'BlockDescription' => '\\StructType\\BlockDescription',
            'ArrayOfContactPersonType' => '\\ArrayType\\ArrayOfContactPersonType',
            'OTA_HotelInvBlockNotifRS' => '\\StructType\\OTA_HotelInvBlockNotifRS',
            'InvBlockCodeRefs' => '\\StructType\\InvBlockCodeRefs',
            'InvBlockCodeRefType' => '\\StructType\\InvBlockCodeRefType',
            'OTA_HotelInvCountNotifRQ' => '\\StructType\\OTA_HotelInvCountNotifRQ',
            'InvCountType' => '\\StructType\\InvCountType',
            'BaseInvCountType' => '\\StructType\\BaseInvCountType',
            'OffSell' => '\\StructType\\OffSell',
            'ArrayOfBaseInvCountTypeInvCount' => '\\ArrayType\\ArrayOfBaseInvCountTypeInvCount',
            'InvCount' => '\\StructType\\InvCount',
            'InvBlockCutoff' => '\\StructType\\InvBlockCutoff',
            'OTA_HotelInvCountNotifRS' => '\\StructType\\OTA_HotelInvCountNotifRS',
            'OTA_HotelRatePlanRQ' => '\\StructType\\OTA_HotelRatePlanRQ',
            'ArrayOfOTA_HotelRatePlanRQRatePlan' => '\\ArrayType\\ArrayOfOTA_HotelRatePlanRQRatePlan',
            'DateRange' => '\\StructType\\DateRange',
            'Offers' => '\\StructType\\Offers',
            'Offer' => '\\StructType\\Offer',
            'ArrayOfRatePlanCandidatesTypeRatePlanCandidate' => '\\ArrayType\\ArrayOfRatePlanCandidatesTypeRatePlanCandidate',
            'RatePlanCandidate' => '\\StructType\\RatePlanCandidate',
            'ArrivalPolicy' => '\\StructType\\ArrivalPolicy',
            'RatePlanCommission' => '\\StructType\\RatePlanCommission',
            'ArrayOfRatePlanCandidatesTypeRatePlanCandidateHotelRef' => '\\ArrayType\\ArrayOfRatePlanCandidatesTypeRatePlanCandidateHotelRef',
            'OTA_HotelRatePlanRS' => '\\StructType\\OTA_HotelRatePlanRS',
            'SecurityHeaderType' => '\\StructType\\SecurityHeaderType',
        );
    }
}
