<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AvailRequestSegmentsType StructType
 * @subpackage Structs
 */
class AvailRequestSegmentsType extends AbstractStructBase
{
    /**
     * The AvailRequestSegment
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AvailRequestSegment[]
     */
    public $AvailRequestSegment;
    /**
     * Constructor method for AvailRequestSegmentsType
     * @uses AvailRequestSegmentsType::setAvailRequestSegment()
     * @param \StructType\AvailRequestSegment[] $availRequestSegment
     */
    public function __construct(array $availRequestSegment = array())
    {
        $this
            ->setAvailRequestSegment($availRequestSegment);
    }
    /**
     * Get AvailRequestSegment value
     * @return \StructType\AvailRequestSegment[]|null
     */
    public function getAvailRequestSegment()
    {
        return $this->AvailRequestSegment;
    }
    /**
     * This method is responsible for validating the values passed to the setAvailRequestSegment method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAvailRequestSegment method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAvailRequestSegmentForArrayConstraintsFromSetAvailRequestSegment(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $availRequestSegmentsTypeAvailRequestSegmentItem) {
            // validation for constraint: itemType
            if (!$availRequestSegmentsTypeAvailRequestSegmentItem instanceof \StructType\AvailRequestSegment) {
                $invalidValues[] = is_object($availRequestSegmentsTypeAvailRequestSegmentItem) ? get_class($availRequestSegmentsTypeAvailRequestSegmentItem) : sprintf('%s(%s)', gettype($availRequestSegmentsTypeAvailRequestSegmentItem), var_export($availRequestSegmentsTypeAvailRequestSegmentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AvailRequestSegment property can only contain items of type \StructType\AvailRequestSegment, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AvailRequestSegment value
     * @throws \InvalidArgumentException
     * @param \StructType\AvailRequestSegment[] $availRequestSegment
     * @return \StructType\AvailRequestSegmentsType
     */
    public function setAvailRequestSegment(array $availRequestSegment = array())
    {
        // validation for constraint: array
        if ('' !== ($availRequestSegmentArrayErrorMessage = self::validateAvailRequestSegmentForArrayConstraintsFromSetAvailRequestSegment($availRequestSegment))) {
            throw new \InvalidArgumentException($availRequestSegmentArrayErrorMessage, __LINE__);
        }
        $this->AvailRequestSegment = $availRequestSegment;
        return $this;
    }
    /**
     * Add item to AvailRequestSegment value
     * @throws \InvalidArgumentException
     * @param \StructType\AvailRequestSegment $item
     * @return \StructType\AvailRequestSegmentsType
     */
    public function addToAvailRequestSegment(\StructType\AvailRequestSegment $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AvailRequestSegment) {
            throw new \InvalidArgumentException(sprintf('The AvailRequestSegment property can only contain items of type \StructType\AvailRequestSegment, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AvailRequestSegment[] = $item;
        return $this;
    }
}
