<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GuaranteeType StructType
 * @subpackage Structs
 */
class GuaranteeType extends AbstractStructBase
{
    /**
     * The GuaranteesAccepted
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfGuaranteeTypeGuaranteeAccepted
     */
    public $GuaranteesAccepted;
    /**
     * The Deadline
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Deadline
     */
    public $Deadline;
    /**
     * The Comments
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfCommentTypeComment
     */
    public $Comments;
    /**
     * The GuaranteeDescription
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ParagraphType[]
     */
    public $GuaranteeDescription;
    /**
     * The GuaranteeCode
     * @var string
     */
    public $GuaranteeCode;
    /**
     * The GuaranteeType
     * @var string
     */
    public $GuaranteeType;
    /**
     * Constructor method for GuaranteeType
     * @uses GuaranteeType::setGuaranteesAccepted()
     * @uses GuaranteeType::setDeadline()
     * @uses GuaranteeType::setComments()
     * @uses GuaranteeType::setGuaranteeDescription()
     * @uses GuaranteeType::setGuaranteeCode()
     * @uses GuaranteeType::setGuaranteeType()
     * @param \ArrayType\ArrayOfGuaranteeTypeGuaranteeAccepted $guaranteesAccepted
     * @param \StructType\Deadline $deadline
     * @param \ArrayType\ArrayOfCommentTypeComment $comments
     * @param \StructType\ParagraphType[] $guaranteeDescription
     * @param string $guaranteeCode
     * @param string $guaranteeType
     */
    public function __construct(\ArrayType\ArrayOfGuaranteeTypeGuaranteeAccepted $guaranteesAccepted = null, \StructType\Deadline $deadline = null, \ArrayType\ArrayOfCommentTypeComment $comments = null, array $guaranteeDescription = array(), $guaranteeCode = null, $guaranteeType = null)
    {
        $this
            ->setGuaranteesAccepted($guaranteesAccepted)
            ->setDeadline($deadline)
            ->setComments($comments)
            ->setGuaranteeDescription($guaranteeDescription)
            ->setGuaranteeCode($guaranteeCode)
            ->setGuaranteeType($guaranteeType);
    }
    /**
     * Get GuaranteesAccepted value
     * @return \ArrayType\ArrayOfGuaranteeTypeGuaranteeAccepted|null
     */
    public function getGuaranteesAccepted()
    {
        return $this->GuaranteesAccepted;
    }
    /**
     * Set GuaranteesAccepted value
     * @param \ArrayType\ArrayOfGuaranteeTypeGuaranteeAccepted $guaranteesAccepted
     * @return \StructType\GuaranteeType
     */
    public function setGuaranteesAccepted(\ArrayType\ArrayOfGuaranteeTypeGuaranteeAccepted $guaranteesAccepted = null)
    {
        $this->GuaranteesAccepted = $guaranteesAccepted;
        return $this;
    }
    /**
     * Get Deadline value
     * @return \StructType\Deadline|null
     */
    public function getDeadline()
    {
        return $this->Deadline;
    }
    /**
     * Set Deadline value
     * @param \StructType\Deadline $deadline
     * @return \StructType\GuaranteeType
     */
    public function setDeadline(\StructType\Deadline $deadline = null)
    {
        $this->Deadline = $deadline;
        return $this;
    }
    /**
     * Get Comments value
     * @return \ArrayType\ArrayOfCommentTypeComment|null
     */
    public function getComments()
    {
        return $this->Comments;
    }
    /**
     * Set Comments value
     * @param \ArrayType\ArrayOfCommentTypeComment $comments
     * @return \StructType\GuaranteeType
     */
    public function setComments(\ArrayType\ArrayOfCommentTypeComment $comments = null)
    {
        $this->Comments = $comments;
        return $this;
    }
    /**
     * Get GuaranteeDescription value
     * @return \StructType\ParagraphType[]|null
     */
    public function getGuaranteeDescription()
    {
        return $this->GuaranteeDescription;
    }
    /**
     * This method is responsible for validating the values passed to the setGuaranteeDescription method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGuaranteeDescription method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGuaranteeDescriptionForArrayConstraintsFromSetGuaranteeDescription(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $guaranteeTypeGuaranteeDescriptionItem) {
            // validation for constraint: itemType
            if (!$guaranteeTypeGuaranteeDescriptionItem instanceof \StructType\ParagraphType) {
                $invalidValues[] = is_object($guaranteeTypeGuaranteeDescriptionItem) ? get_class($guaranteeTypeGuaranteeDescriptionItem) : sprintf('%s(%s)', gettype($guaranteeTypeGuaranteeDescriptionItem), var_export($guaranteeTypeGuaranteeDescriptionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GuaranteeDescription property can only contain items of type \StructType\ParagraphType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GuaranteeDescription value
     * @throws \InvalidArgumentException
     * @param \StructType\ParagraphType[] $guaranteeDescription
     * @return \StructType\GuaranteeType
     */
    public function setGuaranteeDescription(array $guaranteeDescription = array())
    {
        // validation for constraint: array
        if ('' !== ($guaranteeDescriptionArrayErrorMessage = self::validateGuaranteeDescriptionForArrayConstraintsFromSetGuaranteeDescription($guaranteeDescription))) {
            throw new \InvalidArgumentException($guaranteeDescriptionArrayErrorMessage, __LINE__);
        }
        $this->GuaranteeDescription = $guaranteeDescription;
        return $this;
    }
    /**
     * Add item to GuaranteeDescription value
     * @throws \InvalidArgumentException
     * @param \StructType\ParagraphType $item
     * @return \StructType\GuaranteeType
     */
    public function addToGuaranteeDescription(\StructType\ParagraphType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ParagraphType) {
            throw new \InvalidArgumentException(sprintf('The GuaranteeDescription property can only contain items of type \StructType\ParagraphType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GuaranteeDescription[] = $item;
        return $this;
    }
    /**
     * Get GuaranteeCode value
     * @return string|null
     */
    public function getGuaranteeCode()
    {
        return $this->GuaranteeCode;
    }
    /**
     * Set GuaranteeCode value
     * @param string $guaranteeCode
     * @return \StructType\GuaranteeType
     */
    public function setGuaranteeCode($guaranteeCode = null)
    {
        // validation for constraint: string
        if (!is_null($guaranteeCode) && !is_string($guaranteeCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($guaranteeCode, true), gettype($guaranteeCode)), __LINE__);
        }
        $this->GuaranteeCode = $guaranteeCode;
        return $this;
    }
    /**
     * Get GuaranteeType value
     * @return string|null
     */
    public function getGuaranteeType()
    {
        return $this->GuaranteeType;
    }
    /**
     * Set GuaranteeType value
     * @param string $guaranteeType
     * @return \StructType\GuaranteeType
     */
    public function setGuaranteeType($guaranteeType = null)
    {
        // validation for constraint: string
        if (!is_null($guaranteeType) && !is_string($guaranteeType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($guaranteeType, true), gettype($guaranteeType)), __LINE__);
        }
        $this->GuaranteeType = $guaranteeType;
        return $this;
    }
}
