<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HotelDescriptiveContents StructType
 * @subpackage Structs
 */
class HotelDescriptiveContents extends AbstractStructBase
{
    /**
     * The HotelDescriptiveContent
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\HotelDescriptiveContent[]
     */
    public $HotelDescriptiveContent;
    /**
     * Constructor method for HotelDescriptiveContents
     * @uses HotelDescriptiveContents::setHotelDescriptiveContent()
     * @param \StructType\HotelDescriptiveContent[] $hotelDescriptiveContent
     */
    public function __construct(array $hotelDescriptiveContent = array())
    {
        $this
            ->setHotelDescriptiveContent($hotelDescriptiveContent);
    }
    /**
     * Get HotelDescriptiveContent value
     * @return \StructType\HotelDescriptiveContent[]|null
     */
    public function getHotelDescriptiveContent()
    {
        return $this->HotelDescriptiveContent;
    }
    /**
     * This method is responsible for validating the values passed to the setHotelDescriptiveContent method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHotelDescriptiveContent method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHotelDescriptiveContentForArrayConstraintsFromSetHotelDescriptiveContent(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $hotelDescriptiveContentsHotelDescriptiveContentItem) {
            // validation for constraint: itemType
            if (!$hotelDescriptiveContentsHotelDescriptiveContentItem instanceof \StructType\HotelDescriptiveContent) {
                $invalidValues[] = is_object($hotelDescriptiveContentsHotelDescriptiveContentItem) ? get_class($hotelDescriptiveContentsHotelDescriptiveContentItem) : sprintf('%s(%s)', gettype($hotelDescriptiveContentsHotelDescriptiveContentItem), var_export($hotelDescriptiveContentsHotelDescriptiveContentItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HotelDescriptiveContent property can only contain items of type \StructType\HotelDescriptiveContent, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HotelDescriptiveContent value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelDescriptiveContent[] $hotelDescriptiveContent
     * @return \StructType\HotelDescriptiveContents
     */
    public function setHotelDescriptiveContent(array $hotelDescriptiveContent = array())
    {
        // validation for constraint: array
        if ('' !== ($hotelDescriptiveContentArrayErrorMessage = self::validateHotelDescriptiveContentForArrayConstraintsFromSetHotelDescriptiveContent($hotelDescriptiveContent))) {
            throw new \InvalidArgumentException($hotelDescriptiveContentArrayErrorMessage, __LINE__);
        }
        $this->HotelDescriptiveContent = $hotelDescriptiveContent;
        return $this;
    }
    /**
     * Add item to HotelDescriptiveContent value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelDescriptiveContent $item
     * @return \StructType\HotelDescriptiveContents
     */
    public function addToHotelDescriptiveContent(\StructType\HotelDescriptiveContent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HotelDescriptiveContent) {
            throw new \InvalidArgumentException(sprintf('The HotelDescriptiveContent property can only contain items of type \StructType\HotelDescriptiveContent, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HotelDescriptiveContent[] = $item;
        return $this;
    }
}
