<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HotelReservationsType StructType
 * @subpackage Structs
 */
class HotelReservationsType extends AbstractStructBase
{
    /**
     * The HotelReservation
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\HotelReservation[]
     */
    public $HotelReservation;
    /**
     * Constructor method for HotelReservationsType
     * @uses HotelReservationsType::setHotelReservation()
     * @param \StructType\HotelReservation[] $hotelReservation
     */
    public function __construct(array $hotelReservation = array())
    {
        $this
            ->setHotelReservation($hotelReservation);
    }
    /**
     * Get HotelReservation value
     * @return \StructType\HotelReservation[]|null
     */
    public function getHotelReservation()
    {
        return $this->HotelReservation;
    }
    /**
     * This method is responsible for validating the values passed to the setHotelReservation method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHotelReservation method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHotelReservationForArrayConstraintsFromSetHotelReservation(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $hotelReservationsTypeHotelReservationItem) {
            // validation for constraint: itemType
            if (!$hotelReservationsTypeHotelReservationItem instanceof \StructType\HotelReservation) {
                $invalidValues[] = is_object($hotelReservationsTypeHotelReservationItem) ? get_class($hotelReservationsTypeHotelReservationItem) : sprintf('%s(%s)', gettype($hotelReservationsTypeHotelReservationItem), var_export($hotelReservationsTypeHotelReservationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HotelReservation property can only contain items of type \StructType\HotelReservation, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HotelReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelReservation[] $hotelReservation
     * @return \StructType\HotelReservationsType
     */
    public function setHotelReservation(array $hotelReservation = array())
    {
        // validation for constraint: array
        if ('' !== ($hotelReservationArrayErrorMessage = self::validateHotelReservationForArrayConstraintsFromSetHotelReservation($hotelReservation))) {
            throw new \InvalidArgumentException($hotelReservationArrayErrorMessage, __LINE__);
        }
        $this->HotelReservation = $hotelReservation;
        return $this;
    }
    /**
     * Add item to HotelReservation value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelReservation $item
     * @return \StructType\HotelReservationsType
     */
    public function addToHotelReservation(\StructType\HotelReservation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HotelReservation) {
            throw new \InvalidArgumentException(sprintf('The HotelReservation property can only contain items of type \StructType\HotelReservation, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HotelReservation[] = $item;
        return $this;
    }
}
