<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MiscChargeOrder StructType
 * @subpackage Structs
 */
class MiscChargeOrder extends AbstractStructBase
{
    /**
     * The TicketNumber
     * @var string
     */
    public $TicketNumber;
    /**
     * The OriginalTicketNumber
     * @var string
     */
    public $OriginalTicketNumber;
    /**
     * The OriginalIssuePlace
     * @var string
     */
    public $OriginalIssuePlace;
    /**
     * The OriginalIssueDate
     * @var string
     */
    public $OriginalIssueDate;
    /**
     * The OriginalIssueIATA
     * @var string
     */
    public $OriginalIssueIATA;
    /**
     * The OriginalPaymentForm
     * @var string
     */
    public $OriginalPaymentForm;
    /**
     * The CheckInhibitorType
     * @var string
     */
    public $CheckInhibitorType;
    /**
     * The CouponRPHs
     * @var string[]
     */
    public $CouponRPHs;
    /**
     * The PaperMCO_ExistInd
     * @var bool
     */
    public $PaperMCO_ExistInd;
    /**
     * Constructor method for MiscChargeOrder
     * @uses MiscChargeOrder::setTicketNumber()
     * @uses MiscChargeOrder::setOriginalTicketNumber()
     * @uses MiscChargeOrder::setOriginalIssuePlace()
     * @uses MiscChargeOrder::setOriginalIssueDate()
     * @uses MiscChargeOrder::setOriginalIssueIATA()
     * @uses MiscChargeOrder::setOriginalPaymentForm()
     * @uses MiscChargeOrder::setCheckInhibitorType()
     * @uses MiscChargeOrder::setCouponRPHs()
     * @uses MiscChargeOrder::setPaperMCO_ExistInd()
     * @param string $ticketNumber
     * @param string $originalTicketNumber
     * @param string $originalIssuePlace
     * @param string $originalIssueDate
     * @param string $originalIssueIATA
     * @param string $originalPaymentForm
     * @param string $checkInhibitorType
     * @param string[] $couponRPHs
     * @param bool $paperMCO_ExistInd
     */
    public function __construct($ticketNumber = null, $originalTicketNumber = null, $originalIssuePlace = null, $originalIssueDate = null, $originalIssueIATA = null, $originalPaymentForm = null, $checkInhibitorType = null, array $couponRPHs = array(), $paperMCO_ExistInd = null)
    {
        $this
            ->setTicketNumber($ticketNumber)
            ->setOriginalTicketNumber($originalTicketNumber)
            ->setOriginalIssuePlace($originalIssuePlace)
            ->setOriginalIssueDate($originalIssueDate)
            ->setOriginalIssueIATA($originalIssueIATA)
            ->setOriginalPaymentForm($originalPaymentForm)
            ->setCheckInhibitorType($checkInhibitorType)
            ->setCouponRPHs($couponRPHs)
            ->setPaperMCO_ExistInd($paperMCO_ExistInd);
    }
    /**
     * Get TicketNumber value
     * @return string|null
     */
    public function getTicketNumber()
    {
        return $this->TicketNumber;
    }
    /**
     * Set TicketNumber value
     * @param string $ticketNumber
     * @return \StructType\MiscChargeOrder
     */
    public function setTicketNumber($ticketNumber = null)
    {
        // validation for constraint: string
        if (!is_null($ticketNumber) && !is_string($ticketNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($ticketNumber, true), gettype($ticketNumber)), __LINE__);
        }
        $this->TicketNumber = $ticketNumber;
        return $this;
    }
    /**
     * Get OriginalTicketNumber value
     * @return string|null
     */
    public function getOriginalTicketNumber()
    {
        return $this->OriginalTicketNumber;
    }
    /**
     * Set OriginalTicketNumber value
     * @param string $originalTicketNumber
     * @return \StructType\MiscChargeOrder
     */
    public function setOriginalTicketNumber($originalTicketNumber = null)
    {
        // validation for constraint: string
        if (!is_null($originalTicketNumber) && !is_string($originalTicketNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originalTicketNumber, true), gettype($originalTicketNumber)), __LINE__);
        }
        $this->OriginalTicketNumber = $originalTicketNumber;
        return $this;
    }
    /**
     * Get OriginalIssuePlace value
     * @return string|null
     */
    public function getOriginalIssuePlace()
    {
        return $this->OriginalIssuePlace;
    }
    /**
     * Set OriginalIssuePlace value
     * @param string $originalIssuePlace
     * @return \StructType\MiscChargeOrder
     */
    public function setOriginalIssuePlace($originalIssuePlace = null)
    {
        // validation for constraint: string
        if (!is_null($originalIssuePlace) && !is_string($originalIssuePlace)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originalIssuePlace, true), gettype($originalIssuePlace)), __LINE__);
        }
        $this->OriginalIssuePlace = $originalIssuePlace;
        return $this;
    }
    /**
     * Get OriginalIssueDate value
     * @return string|null
     */
    public function getOriginalIssueDate()
    {
        return $this->OriginalIssueDate;
    }
    /**
     * Set OriginalIssueDate value
     * @param string $originalIssueDate
     * @return \StructType\MiscChargeOrder
     */
    public function setOriginalIssueDate($originalIssueDate = null)
    {
        // validation for constraint: string
        if (!is_null($originalIssueDate) && !is_string($originalIssueDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originalIssueDate, true), gettype($originalIssueDate)), __LINE__);
        }
        $this->OriginalIssueDate = $originalIssueDate;
        return $this;
    }
    /**
     * Get OriginalIssueIATA value
     * @return string|null
     */
    public function getOriginalIssueIATA()
    {
        return $this->OriginalIssueIATA;
    }
    /**
     * Set OriginalIssueIATA value
     * @param string $originalIssueIATA
     * @return \StructType\MiscChargeOrder
     */
    public function setOriginalIssueIATA($originalIssueIATA = null)
    {
        // validation for constraint: string
        if (!is_null($originalIssueIATA) && !is_string($originalIssueIATA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originalIssueIATA, true), gettype($originalIssueIATA)), __LINE__);
        }
        $this->OriginalIssueIATA = $originalIssueIATA;
        return $this;
    }
    /**
     * Get OriginalPaymentForm value
     * @return string|null
     */
    public function getOriginalPaymentForm()
    {
        return $this->OriginalPaymentForm;
    }
    /**
     * Set OriginalPaymentForm value
     * @param string $originalPaymentForm
     * @return \StructType\MiscChargeOrder
     */
    public function setOriginalPaymentForm($originalPaymentForm = null)
    {
        // validation for constraint: string
        if (!is_null($originalPaymentForm) && !is_string($originalPaymentForm)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($originalPaymentForm, true), gettype($originalPaymentForm)), __LINE__);
        }
        $this->OriginalPaymentForm = $originalPaymentForm;
        return $this;
    }
    /**
     * Get CheckInhibitorType value
     * @return string|null
     */
    public function getCheckInhibitorType()
    {
        return $this->CheckInhibitorType;
    }
    /**
     * Set CheckInhibitorType value
     * @param string $checkInhibitorType
     * @return \StructType\MiscChargeOrder
     */
    public function setCheckInhibitorType($checkInhibitorType = null)
    {
        // validation for constraint: string
        if (!is_null($checkInhibitorType) && !is_string($checkInhibitorType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($checkInhibitorType, true), gettype($checkInhibitorType)), __LINE__);
        }
        $this->CheckInhibitorType = $checkInhibitorType;
        return $this;
    }
    /**
     * Get CouponRPHs value
     * @return string[]|null
     */
    public function getCouponRPHs()
    {
        return $this->CouponRPHs;
    }
    /**
     * This method is responsible for validating the values passed to the setCouponRPHs method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCouponRPHs method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCouponRPHsForArrayConstraintsFromSetCouponRPHs(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $miscChargeOrderCouponRPHsItem) {
            // validation for constraint: itemType
            if (!is_string($miscChargeOrderCouponRPHsItem)) {
                $invalidValues[] = is_object($miscChargeOrderCouponRPHsItem) ? get_class($miscChargeOrderCouponRPHsItem) : sprintf('%s(%s)', gettype($miscChargeOrderCouponRPHsItem), var_export($miscChargeOrderCouponRPHsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CouponRPHs property can only contain items of type string, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CouponRPHs value
     * @throws \InvalidArgumentException
     * @param string[] $couponRPHs
     * @return \StructType\MiscChargeOrder
     */
    public function setCouponRPHs(array $couponRPHs = array())
    {
        // validation for constraint: array
        if ('' !== ($couponRPHsArrayErrorMessage = self::validateCouponRPHsForArrayConstraintsFromSetCouponRPHs($couponRPHs))) {
            throw new \InvalidArgumentException($couponRPHsArrayErrorMessage, __LINE__);
        }
        $this->CouponRPHs = $couponRPHs;
        return $this;
    }
    /**
     * Add item to CouponRPHs value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \StructType\MiscChargeOrder
     */
    public function addToCouponRPHs($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The CouponRPHs property can only contain items of type string, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CouponRPHs[] = $item;
        return $this;
    }
    /**
     * Get PaperMCO_ExistInd value
     * @return bool|null
     */
    public function getPaperMCO_ExistInd()
    {
        return $this->PaperMCO_ExistInd;
    }
    /**
     * Set PaperMCO_ExistInd value
     * @param bool $paperMCO_ExistInd
     * @return \StructType\MiscChargeOrder
     */
    public function setPaperMCO_ExistInd($paperMCO_ExistInd = null)
    {
        // validation for constraint: boolean
        if (!is_null($paperMCO_ExistInd) && !is_bool($paperMCO_ExistInd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($paperMCO_ExistInd, true), gettype($paperMCO_ExistInd)), __LINE__);
        }
        $this->PaperMCO_ExistInd = $paperMCO_ExistInd;
        return $this;
    }
}
