<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Position StructType
 * @subpackage Structs
 */
class Position extends AbstractStructBase
{
    /**
     * The Latitude
     * @var string
     */
    public $Latitude;
    /**
     * The Longitude
     * @var string
     */
    public $Longitude;
    /**
     * The Altitude
     * @var string
     */
    public $Altitude;
    /**
     * The AltitudeUnitOfMeasureCode
     * @var string
     */
    public $AltitudeUnitOfMeasureCode;
    /**
     * The PositionAccuracyCode
     * @var string
     */
    public $PositionAccuracyCode;
    /**
     * Constructor method for Position
     * @uses Position::setLatitude()
     * @uses Position::setLongitude()
     * @uses Position::setAltitude()
     * @uses Position::setAltitudeUnitOfMeasureCode()
     * @uses Position::setPositionAccuracyCode()
     * @param string $latitude
     * @param string $longitude
     * @param string $altitude
     * @param string $altitudeUnitOfMeasureCode
     * @param string $positionAccuracyCode
     */
    public function __construct($latitude = null, $longitude = null, $altitude = null, $altitudeUnitOfMeasureCode = null, $positionAccuracyCode = null)
    {
        $this
            ->setLatitude($latitude)
            ->setLongitude($longitude)
            ->setAltitude($altitude)
            ->setAltitudeUnitOfMeasureCode($altitudeUnitOfMeasureCode)
            ->setPositionAccuracyCode($positionAccuracyCode);
    }
    /**
     * Get Latitude value
     * @return string|null
     */
    public function getLatitude()
    {
        return $this->Latitude;
    }
    /**
     * Set Latitude value
     * @param string $latitude
     * @return \StructType\Position
     */
    public function setLatitude($latitude = null)
    {
        // validation for constraint: string
        if (!is_null($latitude) && !is_string($latitude)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($latitude, true), gettype($latitude)), __LINE__);
        }
        $this->Latitude = $latitude;
        return $this;
    }
    /**
     * Get Longitude value
     * @return string|null
     */
    public function getLongitude()
    {
        return $this->Longitude;
    }
    /**
     * Set Longitude value
     * @param string $longitude
     * @return \StructType\Position
     */
    public function setLongitude($longitude = null)
    {
        // validation for constraint: string
        if (!is_null($longitude) && !is_string($longitude)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($longitude, true), gettype($longitude)), __LINE__);
        }
        $this->Longitude = $longitude;
        return $this;
    }
    /**
     * Get Altitude value
     * @return string|null
     */
    public function getAltitude()
    {
        return $this->Altitude;
    }
    /**
     * Set Altitude value
     * @param string $altitude
     * @return \StructType\Position
     */
    public function setAltitude($altitude = null)
    {
        // validation for constraint: string
        if (!is_null($altitude) && !is_string($altitude)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($altitude, true), gettype($altitude)), __LINE__);
        }
        $this->Altitude = $altitude;
        return $this;
    }
    /**
     * Get AltitudeUnitOfMeasureCode value
     * @return string|null
     */
    public function getAltitudeUnitOfMeasureCode()
    {
        return $this->AltitudeUnitOfMeasureCode;
    }
    /**
     * Set AltitudeUnitOfMeasureCode value
     * @param string $altitudeUnitOfMeasureCode
     * @return \StructType\Position
     */
    public function setAltitudeUnitOfMeasureCode($altitudeUnitOfMeasureCode = null)
    {
        // validation for constraint: string
        if (!is_null($altitudeUnitOfMeasureCode) && !is_string($altitudeUnitOfMeasureCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($altitudeUnitOfMeasureCode, true), gettype($altitudeUnitOfMeasureCode)), __LINE__);
        }
        $this->AltitudeUnitOfMeasureCode = $altitudeUnitOfMeasureCode;
        return $this;
    }
    /**
     * Get PositionAccuracyCode value
     * @return string|null
     */
    public function getPositionAccuracyCode()
    {
        return $this->PositionAccuracyCode;
    }
    /**
     * Set PositionAccuracyCode value
     * @param string $positionAccuracyCode
     * @return \StructType\Position
     */
    public function setPositionAccuracyCode($positionAccuracyCode = null)
    {
        // validation for constraint: string
        if (!is_null($positionAccuracyCode) && !is_string($positionAccuracyCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($positionAccuracyCode, true), gettype($positionAccuracyCode)), __LINE__);
        }
        $this->PositionAccuracyCode = $positionAccuracyCode;
        return $this;
    }
}
